/* tga.h
 * Fonctions permettant la lecture et l'criture d'images Targa TGA
 *
 * Auteur: VOURIOT Thierry
 * Web: http://thierry.vouriot.free.fr
 * Email: thierry.vouriot@free.fr
 * Date: 09 septembre 2002
 */
 
/* log
 * 30/08/2002 prise en charge des images 8 bits
 * 09/09/2002 prise en charge des images 16 bits
 */
 
#ifndef _TGA_H
#define _TGA_H

#ifdef _WIN32
#include <windows.h>
#endif

#include <GL/gl.h>
#include <stdio.h>
#include <stdlib.h>

/* Structure permettant de stocker une image TGA */
typedef struct {
	GLenum texFormat;	// GL_RGB, GL_RGBA ou GL_LUMINANCE
	short int imageWidth;
	short int imageHeight;
	unsigned char bitCount;
	unsigned char *imageData;
} TGAFILE;

/* Codes erreurs de retour des fonctions */
#define TGA_FILE_NOT_FOUND 13
#define TGA_BAD_IMAGE_TYPE 14
#define TGA_BAD_BITS 16
#define TGA_BAD_DATA 17
#define TGA_FILE_NOT_CREATE 18
#define TGA_BAD_SIZE 19

/* Fonction permettant de tester si un entier est une puisance de 2 */
int checkSize(int x);

/* Fonction lisant un fichier TGA 8, 24 ou 32 bits et remplissant la structure
 * TGAFILE passe en paramtre
 */
int LoadTGAFile(char *filename, TGAFILE *tgaFile);

/* Fonction crant une image TGA 24 bits dans le fichier filename */
int Write24bitsTGAFile(char *filename, short int width, short int height, unsigned char* imageData); 

#endif 
